<?php
/*
Plugin Name: WP Simple Paypal Donation
Version: v1.5
Plugin URI: http://www.tipsandtricks-hq.com/wordpress-paypal-donation-plugin-942
Author: Ruhul Amin
Author URI: http://www.tipsandtricks-hq.com/
Plugin Description: Wordpress plugin to receive donation in one click. Can be used in the sidebar, posts and pages.
*/

// Some default options
add_option('wp_paypal_donation_email', get_bloginfo('admin_email'));
add_option('paypal_donation_currency', 'USD');
add_option('wp_paypal_donate_header', 'Donation');

function paypal_donation_receive()
{
    $paypal_email = get_option('wp_paypal_donation_email');
    $donation_currency = get_option('paypal_donation_currency');
    $paypal_subject = get_option('wp_paypal_donate_header');
    $return_url = get_option('wp_paypal_donate_return_url');
	$donation_button = get_bloginfo('wpurl')."/wp-content/plugins/wp-simple-paypal-donation/donate_btn.gif";

    /* === Paypal form === */
    $output .= '
        <form action="https://www.paypal.com/cgi-bin/webscr" method="post">
        <input type="hidden" name="cmd" value="_donations" />
    ';
    $output .= "<input type=\"hidden\" name=\"business\" value=\"$paypal_email\" />";
    $output .= "<input type=\"hidden\" name=\"bn\" value=\"TipsandTricks_SP\" />";
    $output .= "<input type=\"hidden\" name=\"item_name\" value=\"$paypal_subject\" />";
    $output .= "<input type=\"hidden\" name=\"currency_code\" value=\"$donation_currency\" />";
    if(!empty($return_url)){
    	$output .= "<input type=\"hidden\" name=\"return\" value=\"$return_url\" />";
    }
    $output .= "<input type=\"image\" src=\"$donation_button\" name=\"submit\" alt=\"Make payments with payPal - it's fast, free and secure!\" />";
    $output .= '</form>';
    /* = end of paypal form = */
    return $output;
}

function wp_paypal_donation_process($content)
{
    if (strpos($content, "<!--wp_paypal_donation-->") !== FALSE)
    {
        $content = preg_replace('/<p>\s*<!--(.*)-->\s*<\/p>/i', "<!--$1-->", $content);
        $content = str_replace('<!--wp_paypal_donation-->', paypal_donation_receive(), $content);
    }
    return $content;
}

// Displays PayPal Donation Accept Options menu
function wp_paypal_donation_add_option_page() {
    if (function_exists('add_options_page')) {
        add_options_page('WP Paypal Donation', 'WP PayPal Donation', 8, __FILE__, 'wp_paypal_donation_options_page');
    }
}

function wp_paypal_donation_options_page() {

    if (isset($_POST['info_update']))
    {
        echo '<div id="message" class="updated fade"><p><strong>';

        update_option('wp_paypal_donation_email', (string)$_POST["wp_paypal_donation_email"]);
        update_option('paypal_donation_currency', (string)$_POST["paypal_donation_currency"]);
        update_option('wp_paypal_donate_header', stripslashes((string)$_POST["wp_paypal_donate_header"]));
        update_option('wp_paypal_donate_return_url', trim($_POST["wp_paypal_donate_return_url"]));
        echo 'Options Updated!';
        echo '</strong></p></div>';
    }

    $paypal_donation_currency = stripslashes(get_option('paypal_donation_currency'));

    ?>

    <div class=wrap>

    <h2>WordPress Paypal Donation Settings</h2>

    <p>For information and updates, please visit:<br />
    <a href="http://www.tipsandtricks-hq.com/?p=942">http://www.tipsandtricks-hq.com/?p=942</a></p>

    <form method="post" action="<?php echo $_SERVER["REQUEST_URI"]; ?>">
    <input type="hidden" name="info_update" id="info_update" value="true" />

    <fieldset class="options">
    <legend>Usage:</legend>

    <p>There are three ways you can use this plugin:</p>
    <ol>
    <li>1. Add the shortcode <code>[wp_paypal_donation]</code> to a post or page to show a donate button.</li>
    <li>2. Call the function from a template file: <strong>&lt;?php echo paypal_donation_receive(); ?&gt;</strong></li>
    <li>3. Use the <strong>WP Paypal Donation</strong> Widget from the Widgets menu</li>
    </ol>

    </fieldset>

    <fieldset class="options">
    <strong><legend>WP Paypal Donation Plugin Options</legend></strong><br />

    <table width="100%" border="0" cellspacing="0" cellpadding="6">

    <tr valign="top"><td width="25%" align="right">
    <strong>Paypal Email address:</strong>
    </td><td align="left">
    <input name="wp_paypal_donation_email" type="text" size="35" value="<?php echo get_option('wp_paypal_donation_email'); ?>"/>
    <br /><i>This is the Paypal Email address where the donations will go</i><br /><br />
    </td></tr>

    <tr valign="top"><td width="25%" align="right">
    <strong>Choose Donation Currency : </strong>
    </td><td align="left">
    <select id="paypal_donation_currency" name="paypal_donation_currency">
    <?php _e('<option value="USD"') ?><?php if ($paypal_donation_currency == "USD") echo " selected " ?><?php _e('>US Dollar</option>') ?>
    <?php _e('<option value="GBP"') ?><?php if ($paypal_donation_currency == "GBP") echo " selected " ?><?php _e('>Pound Sterling</option>') ?>
    <?php _e('<option value="EUR"') ?><?php if ($paypal_donation_currency == "EUR") echo " selected " ?><?php _e('>Euro</option>') ?>
    <?php _e('<option value="AUD"') ?><?php if ($paypal_donation_currency == "AUD") echo " selected " ?><?php _e('>Australian Dollar</option>') ?>
    <?php _e('<option value="CAD"') ?><?php if ($paypal_donation_currency == "CAD") echo " selected " ?><?php _e('>Canadian Dollar</option>') ?>
    <?php _e('<option value="NZD"') ?><?php if ($paypal_donation_currency == "NZD") echo " selected " ?><?php _e('>New Zealand Dollar</option>') ?>
    <?php _e('<option value="HKD"') ?><?php if ($paypal_donation_currency == "HKD") echo " selected " ?><?php _e('>Hong Kong Dollar</option>') ?>
    </select>
    <br /><i>This is the currency for your visitors to make Donations in.</i><br /><br />
    </td></tr>

    <tr valign="top"><td width="25%" align="right">
    <strong>Donation Subject :</strong>
    </td><td align="left">
    <input name="wp_paypal_donate_header" type="text" size="35" value="<?php echo get_option('wp_paypal_donate_header'); ?>"/>
    <br /><i>Enter the reason for the Donation. The visitors will see this text</i><br /><br />
    </td></tr>

    <tr valign="top"><td width="25%" align="right">
    <strong>Return URL :</strong>
    </td><td align="left">
    <input name="wp_paypal_donate_return_url" type="text" size="60" value="<?php echo get_option('wp_paypal_donate_return_url'); ?>"/>
    <br /><i>Enter the URL where you want the donators to return to after the donation.</i><br /><br />
    </td></tr>
    
    </table>
    </fieldset>

    <div class="submit">
        <input type="submit" name="info_update" value="<?php _e('Update options'); ?> &raquo;" />
    </div>

    </form>
    </div><?php
}

function show_wp_paypal_donation_widget($args)
{
	extract($args);
	
	$paypal_donate_subject = get_option('wp_paypal_donate_header');
	echo $before_widget;
	echo $before_title . $paypal_donate_subject . $after_title;
    echo paypal_donation_receive();
    echo $after_widget;
}

function wp_paypal_donation_widget_control()
{
    ?>
    <p>
    <? _e("Set the Plugin Settings from the Settings menu"); ?>
    </p>
    <?php

}
function widget_wp_paypal_donation_init()
{
    $widget_options = array('classname' => 'widget_wp_paypal_donation', 'description' => __( "Display WP Paypal Donation.") );
    wp_register_sidebar_widget('wp_paypal_wp_paypal_donation_widgets_widgets', __('WP Paypal Donation'), 'show_wp_paypal_donation_widget', $widget_options);
    wp_register_widget_control('wp_paypal_donation_widgets', __('WP Paypal Donation'), 'wp_paypal_donation_widget_control' );
}

add_filter('the_content', 'wp_paypal_donation_process');
if (!is_admin()) {
    add_filter('widget_text', 'do_shortcode');
}

add_shortcode('wp_paypal_donation', 'paypal_donation_receive');

add_action('init', 'widget_wp_paypal_donation_init');

// Insert the wp_paypal_donation_add_option_page in the 'admin_menu'
add_action('admin_menu', 'wp_paypal_donation_add_option_page');
